#include <unistd.h>
#include "Convert.h"
#include "8bM_16bS.h"
#include "TempGmurf.h"

/*
** convert2_16bits_stereo: converti le fichier temporaire dont la structure de controle
**                         est passe en argument en stereo 16bits
*/
int	convert2_16bits_stereo(temp)
     t_tempgmurf	*temp;
{
  int			temp_file2;
  size_t		cpt;
  size_t		nb_byte = BUFFER_SIZE;
  unsigned char		buf[BUFFER_SIZE];
  unsigned short int	buf2[(3-temp->chanels)*(3-(temp->bits_per_sample/8))*(BUFFER_SIZE/2)];

  temp_file2 = init_convert(temp->file);
  while (temp->temp_size > 0)
    {
      nb_byte = read(temp->file, &buf, BUFFER_SIZE);
      temp->temp_size -= nb_byte;
      for (cpt = 0; cpt < nb_byte; cpt++)
	if (temp->bits_per_sample == 8)
	  if (temp->chanels == 1)
	    buf2[2 * cpt] = buf2[2 * cpt + 1] = (buf[cpt] << 8)^32768;
          else
	    buf2[cpt] = (buf[cpt] << 8)^32768;
        else
	  if ((cpt % 2) == 0)
	    buf2[cpt] = buf2[cpt + 1] = (buf[cpt + 1] << 8) + buf[cpt];
      write(temp_file2, &buf2, (3-temp->chanels) * (3-(temp->bits_per_sample/8)) * nb_byte);
    } 
  close_convert(temp, temp_file2, temp_file);
  return (0);
}


